#ifndef __PARSE_H
#define __PARSE_H


#define H_TEST 0x0001
#define H_CMP 0x0002

typedef struct __Host
{
  int h_key;

  int h_flag;
  char *_h_addr;

  int h_addcount;
  char ** h_adddata;
  struct __Host * h_next;
} Host;


typedef struct __PutSection
{
  char * ps_name;
  Host * h_next;

  struct __PutSection *ps_next;
} PutSection;

typedef struct __Command
{
    char *c_cmd;
    char *c_value;
    
    struct __Command *c_next;
} Command;

typedef struct __Plugin
{
  char *NameOfExec;
  char *PathOfExec;
  char *NameOfCfg;
  char *PathOfCfg;

  Command *p_cmd;

  PutSection * ps_next;

  struct __Plugin * p_next;
} Plugin;

/**********************************************************/
#define FL_OPENMAINFILE     0x0001
#define FL_OPENONLYMAINFILE 0x0002
#define PIDFILE "/var/run/eyed.pid"
#define STR_PIDFILE "PidFile"
#define PLUGINDIR "/usr/local/lib/eye"
#define STR_PLUGINDIR "PluginDirectory"
#define CONFIGDIR "./"
#define STR_CONFIGDIR "ConfigDirectory"
#define COMMENT_CHAR '#'

extern char * PidFile;

enum {OCF_OK, OCF_CANNOTOPEN, OCF_CANNOTREAD, OCF_CANNOTBEGIN, OCF_CANNOTCONNECT,
	OCF_CANNOTDECLARECURSOR, OCF_FETCHERROR, OCF_SELECTERROR};

int OpenCfgFile(char *name_cfg, int flag);
int CloseCfgFile();
int OpenRcFile();
int CloseRcFile();

Plugin * GetFirstPlugin();
Plugin * GetNextPlugin();       /* =0 if ListOfPlugin == 0 */
Plugin * GetFirstRc();

#endif
