#include <sys/types.h>
#include<sys/shm.h>
#include<sys/ipc.h>
#include<sys/time.h>
#include<sys/resource.h>
#include<sys/wait.h>
#include <sys/signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <netdb.h>
#include <unistd.h>
#include <regex.h>
#include "../include/signal.h"
#include "../include/parse.h"
#include "../include/constr.h"
#include"../include/eye_log.h"

#define BUFFSIZE 255
#define PORTNUM  43 

char buff[BUFFSIZE];
int pid;
extern int CurChaildNumber, ChaildNumber, *ChaildHolder;

typedef struct _reg_list {
	regex_t  exp;
	struct _reg_list * r_next;
	} reg_list;

	reg_list * reg_first=NULL,* reg_next=NULL; 

void
End_ (int sig)
{

	signal(sig,End_);
	raise(SIGINT);
	while(reg_first)
		{
		regfree(&(reg_first->exp));
		reg_next=reg_first->r_next;
		free(reg_first);
		reg_first=reg_next;
	}
	exit(0);
}

void
main(int argc,char * argv[])
{

	key_t key;
	int i,j,fl;
	long len;
	char * mem;

	Plugin * pl;
	PutSection * put;
	Command *c;
	Host * ho;
	CELL_M *ce,*plce;
	short *sh, *shp;
	short sendtime=0;
	int receivesize=0,cursize=0,ChaildNumber=0,sleeptime;
	CELL StartCounter=0;
	char * begin,data[BUFFSIZE];

//Dlya socketov
	int s;
	int nport;
	struct sockaddr_in serv_addr;	
	struct hostent *hp;

	if(argc<2) 
		{
		printf("Missing .cfg file as first parametr\n");
		exit(1);
	}
	printf("Whois: Cfg file %s\n",argv[1]);

//	setpgrp(getpid(),getpid());

//Otkrytie nuzhnogo .cfg failov
	fl=OpenCfgFile(argv[1],0);
 	if(fl==OCF_CANNOTOPEN)
       		 {
       		 printf("Cannot open cfg file\n");
       		 exit(1);
    	}
	printf("Whois: Cfg opened\n");
	pl=GetFirstPlugin();
//End

//Podsoedinenie SHM
	if (argc<1) printf("Argument missing\n"),exit(1);
	if((key=ftok((argc>2) ? argv[2] : "/var/tmp",'e'))<0) perror("ftok"),exit(1);
	if((i=shmget(key,4,0660))<0)perror("shmget1"),exit(1);
	if((mem=shmat(i,0,0660))<0)perror("shmat"),exit(1);
	len=*((long *) mem);
	if((shmdt(mem))<0)perror("shmdt"),exit(1);
	if((i=shmget(key,len,0660))<0)perror("shmget2"),exit(1);
	if((mem=shmat(i,0,0660))<0)perror("shmat"),exit(1);
//End

//Ustanovka signala okonchyaniya
	signal(SIGCHLD,WaitChaild);
	signal(SIGINT,KillChaild);
	signal(SIGHUP,End_);

	plce=GetStatusByName(pl->NameOfCfg,mem);
	
	 for(c=pl->p_cmd; c; c=c->c_next)
 	 	{
        	if(!strcasecmp(c->c_cmd,"StartCounter")) 
            		StartCounter=atoi(c->c_value);
		if(!strcasecmp(c->c_cmd, "SendTime")) 
            		sendtime=atoi(c->c_value);
		if(!strcasecmp(c->c_cmd, "MaxReceiveSize")) 
            		receivesize=atoi(c->c_value);
		if(!strcasecmp(c->c_cmd, "LogFile")) 
            		strcpy(flerrname,c->c_value);
		if(!strcasecmp(c->c_cmd, "ChaildNumber")) 
            		ChaildNumber=atoi(c->c_value);
	}
	if(!sendtime) sendtime=10;
	if(!StartCounter) StartCounter=10;
	if(!receivesize) receivesize=10000;
	if(!ChaildNumber) ChaildNumber=GetHostNumber(pl);
ChaildHolder=(int *) malloc(ChaildNumber*sizeof(pid_t));

#if DEBUG
	remove(flerrname);
#endif
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("Sendtime=%d\n",sendtime);
	printf("Size of reg_list=%d\n",sizeof(reg_list));
	fclose(flerr);
#endif

//Kompilyazciya regulyarnyh vyrazheniy i proverka oshibok v resolvinge
if(!(sh=GetCfgByName(pl->NameOfCfg,mem)))
       	{
        perror("  SHM   pl->NameOfCfg\n");
	plce->status=3;plce->rate=0;	
        exit(1);
}
for (put=pl->ps_next;put;put=put->ps_next)
	{
	if(!(shp=GetPutByName(put->ps_name,sh))) 
       		{
               	perror("  SHM  put->ps_name\n");
 		plce->status=3;plce->rate=0;	
               	exit(1);
       	}
	for(ho=put->h_next;ho;ho=ho->h_next)
		{
		ce=GetCELL_M(shp);
        	if(!ce) break;
		if (reg_first==NULL) reg_first=reg_next=(reg_list *)malloc(sizeof(reg_list));
			else {reg_next->r_next=(reg_list *)malloc(sizeof(reg_list));reg_next=reg_next->r_next;}

#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("malloc at addres %d\n",reg_next);
	printf("AddData is %s\n",ho->h_adddata);
	fclose(flerr);
#endif

		if(!ho->h_adddata) strcpy(data,".*\0");
			else strcpy(data,(ho->h_adddata+1));//Pervym idet /, kotoryi nuzhen dlya adddata v parsere
		if(regcomp(&(reg_next->exp),data,REG_NOSUB)) ce->status=5;//Ne mogu otkompilirovat' reg expr
	
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
	printf("Data is %s\n",data);
	printf("regcomp passed\n");
	fclose(flerr);
#endif

		reg_next->r_next=NULL;	
		hp = gethostbyname(ho->_h_addr);
		if ((!hp)) //Error in resolve 
			{
			ce->rate=0;
			ce->status=4;
			writedblog(pl->NameOfCfg,ho->h_key,ce->status);
		}
	} 
}


//Bol'shoi zcikl
while(1)
	{
	put=pl->ps_next;
	reg_next=reg_first;
	sh=GetCfgByName(pl->NameOfCfg,mem);
	while(put)
		{
		shp=GetPutByName(put->ps_name,sh); 
		ho=put->h_next;
		while(ho)
			{
			pid_t *pid_holder;
			if(atoi(*(ho->h_adddata))) nport=atoi(*(ho->h_adddata));
			else nport = PORTNUM;
			nport = htons((u_short)nport);
			ce=GetCELL_M(shp);
        		if(!ce) break;
			if (CurChaildNumber>=ChaildNumber) sleep(1);
                        if(pid_holder = GetEmptySlot()){ *(pid_holder)=pid=fork(); CurChaildNumber++;}
                                 else raise(SIGINT);
			if(!pid)
			{
			if(ce->status==4) exit(1);
			hp = gethostbyname(ho->_h_addr);
			if ((!hp)) //Error in resolve 
				{
				if(!(ce->status==4))ce->rate=0;
				ce->status=4;
				writedblog(pl->NameOfCfg,ho->h_key,ce->status);
			}
			else
				{
				bzero(&serv_addr,sizeof(serv_addr));
				bcopy(hp->h_addr, &serv_addr.sin_addr, hp->h_length);
       				serv_addr.sin_family = AF_INET;
       				serv_addr.sin_port = nport;
        			if((s = socket(AF_INET,SOCK_STREAM,0)) == -1)
        				{
                			perror("  socket()\n");
					if(plce->status!=2){
						plce->rate=0;
						writedblog(pl->NameOfCfg,ho->h_key,ce->status);
					}
					plce->status=2;	
                			exit(1);
        			}
				if(connect(s,(struct sockaddr *)&serv_addr, sizeof(serv_addr))==-1)
        				{
                			perror("  connect()\n");//Vremenno v sostoyanii DOWN
        				if(ce->status!=6){ 
						ce->rate=0;
						writedblog(pl->NameOfCfg,ho->h_key,ce->status);
					}
					ce->status=6;	
					exit(1);
				} 
				else
					{
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
					printf("%s connected\n",ho->_h_addr);
	fclose(flerr);
#endif
	        			{
                        		int nbytes,fout;
                        		int nmatch;
					regmatch_t * pmatch;
					if(!(*((ho->h_adddata)+1))) strcpy(data,"?\0");
						else strcpy(data,*((ho->h_adddata)+1));
					strcat(data,"\r\n");
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
					printf("AddGet is %s\n",*((ho->h_adddata)+1));
					printf("Get is %s\n",data);
	fclose(flerr);
#endif
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
					printf("%s sending...\n",data);
	fclose(flerr);
#endif
					fout=send(s,data,strlen(data),0);
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
					printf("sended %d bytes\n",fout);
                        		printf("receving...\n");
	fclose(flerr);
#endif
					begin=(char *)malloc(receivesize);
					strcpy(begin,"\0");
					while((nbytes=recv(s,buff,sizeof(buff),0))&&(cursize+nbytes<receivesize))
						{
						strncat(begin+cursize,buff,nbytes);
						cursize+=nbytes;
					}				
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
                        		printf("%s %d\n",begin,nbytes);
                        		printf("*****************\n");
	fclose(flerr);
#endif
					if(!regexec(&(reg_next->exp),begin,nmatch,pmatch,0)) //Est' sovpadenie
						{
						if(ce->status!=0){writedblog(pl->NameOfCfg,ho->h_key,0);ce->rate=0;}
						ce->status=0;
						ce->cell=StartCounter;
					}
						else {
							if ((ce->status!=0)&&(ce->status!=1)) ce->cell=StartCounter;
							if (ce->status!=1) ce->status=0;
						}
						
						//T.e. oshibka #1 budet oznachat' chto connect est', no shablon ne sovpadaet

					free(begin);	
					}
				}
				close(s);	
			}
			exit(1);
			}//End fork()
			ho=ho->h_next;
			reg_next=reg_next->r_next;
		}
		put=put->ps_next;
	}
sleeptime = sendtime;
while(sleeptime=sleep(sleeptime)); 
#if DEBUG
	flerr=freopen(flerrname,"a",stdout);
                        		printf("***** Next ****** cicle ******\n");
	fclose(flerr);
#endif
}

close(s);
}//main()
